/*
 * klavesnice k alarmu
 * pic 16F628
 */

#include	<pic.h>
__CONFIG   (UNPROTECT&UNPROTECT&LVPDIS&BOREN&MCLREN&PWRTEN&WDTDIS&INTIO);

#include	<stdio.h>
#include	"delay.h"


#define bitset(var,bitno) ((var)|= 1<<(bitno))
#define bitclr(var,bitno) ((var)&=~(1<<(bitno)))
#define PORTBIT(adr, bit)       ((unsigned)(&adr)*8+(bit))
static bit      COL0 @ PORTBIT(PORTB, 0);  //pripojeni klavesnice 
static bit      COL1 @ PORTBIT(PORTB, 1);
static bit      COL2 @ PORTBIT(PORTB, 2);
static bit      COL3 @ PORTBIT(PORTB, 3);  //v pripade mensi klavesnice 3 x 4 tlacitek neni vyuzito
static bit      ROW0 @ PORTBIT(PORTB, 4);  
static bit      ROW1 @ PORTBIT(PORTB, 5);  
static bit      ROW2 @ PORTBIT(PORTB, 6);  
static bit      ROW3 @ PORTBIT(PORTB, 7); 

static bit      LEDR @ PORTBIT(PORTA, 3);  
static bit      LEDG @ PORTBIT(PORTA, 2); 
static bit      RELE @ PORTBIT(PORTA, 1);  
static bit      PIEZO @ PORTBIT(PORTA, 0); 

unsigned char a=255;
unsigned char i=0;
unsigned char tmp_a=0;
unsigned char code[4]={0,0,0,0};                 	//4 prvkove pole pro ulozeni kodu
unsigned char code_new[4]={0,0,0,0};             //4 prvkove pole pro ulozeni noveho kodu
unsigned char code_new_tmp[4]={0,0,0,0};        	//4 prvkove pole pro ulozeni zalohy noveho kodu
unsigned char key_cnt=0;				//pocitadlo stisku klaves
unsigned char key_cnt1=0;				//pocitadlo stisku klaves u noveho kodu
unsigned char code_ok_cnt=0;			//pocitadlo spravnych cislic kodu
unsigned char err=0;					//priznak chybneho kodu
unsigned char change_code=0;     		//priznak zmeny kodu (stisknuto spravny kod + *
unsigned int  key_timer=0;  			//odpocitavani doby pro zadani kodu
unsigned char err_cnt=0;				//pocitadlo chybnych kodu nebo vyprseni casovych limitu
//------------------------------------------------------------------
void Beep ()
{
PIEZO=1;
DelayMs(50);
PIEZO=0;
}

void CodeErr ()
{
unsigned char j=0;
GIE=0;
err_cnt++;
key_cnt=0;
err=0;
code_ok_cnt=0;
if (err_cnt==3)
  {	
  for(j=0;j<30;j++)
    {								//byl 3x zadan chybny kod nebo vyprsel casovy limit, zablokovani na 1min
    LEDR=(!LEDR);
    PIEZO=(!PIEZO);
    DelayS(1);
    LEDR=(!LEDR);
    PIEZO=(!PIEZO);
    DelayS(1);
    err_cnt=0;
    }
  }
else
  {  
  LEDR=0;
  PIEZO=1;
  DelayS(10);
  LEDR=1;
  PIEZO=0;
  }
GIE=1;
}

void CodeOk()
{
  key_cnt=0;
  code_ok_cnt=0;
  err=0;
  err_cnt=0;
  LEDG=(!LEDG);
  RELE=(!RELE);
  GIE=1;
}

void OverTime ()
{
key_cnt=0;
code_ok_cnt=0;
err=1;
key_timer=0;
CodeErr ();
}

void ChangeCode()
{
unsigned char k=0;
key_cnt=5;
code_ok_cnt=0;
err=0;
for(;;)
    { if (key_timer>=100)
     		{
     		OverTime ();
            change_code=0;  
            break;
    		}       
      if(a != 255 & key_cnt != 0)
      {
          GIE=0;
          DelayMs(100);						
		  PIEZO=1;
		  DelayMs(15);
		  PIEZO=0;
          DelayMs(15);
          PIEZO=1;
		  DelayMs(15);
		  PIEZO=0;
          DelayMs(255);
          switch(key_cnt)
            {
			case 6 : code_new[0]=a; break;
            case 7 : code_new[1]=a; break;
            case 8 : code_new[2]=a; break;
            case 9 : code_new[3]=a; break;
            case 10 : code_new_tmp[0]=a; break;
            case 11 : code_new_tmp[1]=a; break;
            case 12 : code_new_tmp[2]=a; break;
            case 13 : code_new_tmp[3]=a; break;
			}
            a=255;
		  //if (err>=1){CodeErr();}
          if (key_cnt==13)
		  {  		 
		  if (code_new[0]==code_new_tmp[0] && code_new[1]==code_new_tmp[1] && code_new[2]==code_new_tmp[2] && code_new[3]==code_new_tmp[3])     		//kody se shoduhi, prepsan stary a nacten novy
			 {
              GIE=0;
              EEPROM_WRITE(0x00, code_new[0]);
              EEPROM_WRITE(0x01, code_new[1]);
			  EEPROM_WRITE(0x02, code_new[2]);
			  EEPROM_WRITE(0x03, code_new[3]);
              for(k=0;k<3;k++)
   			    {
                PIEZO=1;
                LEDR=(!LEDR);
                DelayMs(255);
                LEDR=(!LEDR);
                PIEZO=0;
				DelayMs(255);
                }
              code[0]=EEPROM_READ(0x00);
              code[1]=EEPROM_READ(0x01);
              code[2]=EEPROM_READ(0x02);
              code[3]=EEPROM_READ(0x03);
			  key_cnt=0;
  			  code_ok_cnt=0;
  			  err=0;
              change_code=0;              
              break;
              }
			 else
              {
			  PIEZO=1;				//kody se neshoduji, ponechan stary
              LEDR=(!LEDR);
              DelayS(3);
              LEDR=(!LEDR);
              PIEZO=0;
              key_cnt=0;
  			  code_ok_cnt=0;
              change_code=0;
  			  err=0;
  			  break;
			  }
          }
          else
          {

          }   
        GIE=1;        
       }
   }
}
 

//------------------------------------------------------------------
main(void)
{
							 //celkova inicializace
   CMCON = 0x07;		 	 // komparatory vypnuty (pro 16F62x)
   TRISA = 0b00000000;       // vse vystupy
   TRISB = 0b11110000;       // 4-7 vstupy (ROW0 - ROW3)
   PORTA = 0;
   PORTB = 0;
   GIE=0;
   
   
   OPTION, T0CS = 0;		//hodinovy signal pro TMR0, 1-RA4/TCKI, 0-fosc/4
   OPTION, T0SE = 0;		//volba hrany hod signalu TMR0, zvysena na 1-sestupnou, 0-vzestupnou na vyvodu RA4/T0CKI
   OPTION, PSA = 0;			//prirazeni preddelice, 1-WDG, 0-TMR0
   OPTION, PS2 = 1; 		//
   OPTION, PS1 = 1;			//bity nastavujici delici pomer preddelice ()
   OPTION, PS0 = 1;			//
//nastaveni INTCON
   INTCON,GIE = 0;			//vsechna preruseni, 1-povoleny, 0-zakazany
   INTCON,PEIE = 0;			//preruseni periferii, 1-nastavena preruseni povolena, 0-nastavena preruseni zakazana
   INTCON,T0IE = 1;         //povoleni preruseni pri preteceni TMR0, 1-povoleno, 0-zakazano
   INTCON,INTE = 0;			//povoleni preruseni od udalosti na RB0/INT, 1-povoleno, 0-zakazano
   INTCON,RBIE = 0;			//povoleni preruseni od zmeny stavu na RB<7:4>, 1-povoleno, 0-zakazano
   INTCON,T0IF = 0;			//priznak preruseni od preteceno TMR0, 1-pretekl, 0-nepretekl
   INTCON,INTF = 0;			//priznak preruseni od udalosti na vyvodu RB0/INT,  1-doslo k nastavene udalosti na RB0 (vzest./sest. hrana), 0-nedoslo k udalosti
        
   
   code[0]=EEPROM_READ(0x08);
   if (code[0]!=99)
   {
   EEPROM_WRITE(0x00,1);
   EEPROM_WRITE(0x01,1);
   EEPROM_WRITE(0x02,1);
   EEPROM_WRITE(0x03,1);
   EEPROM_WRITE(0x08,99);
   }
   DelayMs(255);
   code[0]=EEPROM_READ(0x00);
   code[1]=EEPROM_READ(0x01);
   code[2]=EEPROM_READ(0x02);
   code[3]=EEPROM_READ(0x03);

   RELE=0;
   LEDR=0;
   LEDG=0;
   PIEZO=1;
   DelayS(1);
   PIEZO=0;
   LEDR=1;
   LEDG=1;
   GIE=1;
   
   for(;;) 
		{
        if (key_timer>=100)
     		{
     		OverTime ();
    		}       
		if(a != 255)
        { 
          GIE=0;
          DelayMs(100);						
		  Beep();
          DelayMs(255);						
          switch(key_cnt)
            {
			case 1 : if(a==code[0]){code_ok_cnt++; break;}else{err++; break;}
            case 2 : if(a==code[1]){code_ok_cnt++; break;}else{err++; break;}
            case 3 : if(a==code[2]){code_ok_cnt++; break;}else{err++; break;}
            case 4 : if(a==code[3]){code_ok_cnt++; break;}else{err++; break;}
            case 5 : if(a=='#'){code_ok_cnt++; break;}else{if(a=='*'){code_ok_cnt++; change_code=1; break;}else{err++; break;}}
			}
                		 
		  if (change_code==1&code_ok_cnt==5){GIE=1; ChangeCode();}
		  if (code_ok_cnt==5){a=255; CodeOk();}
		  if (err>=5||key_cnt>=5){CodeErr();}
          
        a=255;
        GIE=1;   
        }
        }

}
static void interrupt
isr(void)
{
if (T0IF==1)
  {
  T0IF=0;									//nulovani priznaku preruseni
  if (key_cnt>=1)
  {									
  key_timer++;
  }                
  COL3=1;
  COL2=1;
  COL1=1;
  COL0=1;

  if (ROW0 || ROW1 || ROW2 || ROW3)
    {										//doslo ke stisku klavesy
    COL3=0;
    COL2=0;
    COL1=0;
    COL0=1;
    if (ROW0==1){a='*';}
    if (ROW1==1){a=7;}
    if (ROW2==1){a=4;}
    if (ROW3==1){a=1;}

	  COL3=0;
	  COL2=0;
	  COL1=1;
	  COL0=0;
	  if (ROW0==1){a=0;}
	  if (ROW1==1){a=8;}
	  if (ROW2==1){a=5;}
	  if (ROW3==1){a=2;}
	
	  COL3=0;
	  COL2=1;
	  COL1=0;
	  COL0=0;
	  if (ROW0==1){a='#';}
	  if (ROW1==1){a=9;}
	  if (ROW2==1){a=6;}
	  if (ROW3==1){a=3;}
	
	  COL3=1;				//zde se nevyuzije (klavesnice jen7x3 - jen pro uplnost)
	  COL2=0;
	  COL1=0;
	  COL0=0;
	  if (ROW0==1){a='A';}
	  if (ROW1==1){a='B';}
	  if (ROW2==1){a='C';}
	  if (ROW3==1){a='D';}
	  
	  tmp_a=a;				//ulozeni pro porovnani s nasledujicim ctenim
	  
	  COL3=0;				//dalsi cteni
	  COL2=0;
	  COL1=0;
	  COL0=1;
	  if (ROW0==1){a='*';}
	  if (ROW1==1){a=7;}
	  if (ROW2==1){a=4;}
	  if (ROW3==1){a=1;}
	
	  COL3=0;
	  COL2=0;
	  COL1=1;
	  COL0=0;
	  if (ROW0==1){a=0;}
	  if (ROW1==1){a=8;}
	  if (ROW2==1){a=5;}
	  if (ROW3==1){a=2;}
	
	  COL3=0;
	  COL2=1;
	  COL1=0;
	  COL0=0;
	  if (ROW0==1){a='#';}
	  if (ROW1==1){a=9;}
	  if (ROW2==1){a=6;}
	  if (ROW3==1){a=3;}
	
	  COL3=1;				//zde se nevyuzije (klavesnice jen7x3 - jen pro uplnost)
	  COL2=0;
	  COL1=0;
	  COL0=0;
	  if (ROW0==1){a='A';}
	  if (ROW1==1){a='B';}
	  if (ROW2==1){a='C';}
	  if (ROW3==1){a='D';}
	
	  if (a==tmp_a){key_cnt++; key_timer=0;}else{a=255;}
   }
   else
   {
   a=255;
   }
  }

}
